
#ifndef KOREDLG_PLUGIN_H
#define KOREDLG_PLUGIN_H

#include <kore/plugin.h>

using namespace kore;

extern "C"
{
    PLUGIN_MAIN_HDR(libHandle,libName,libPath,libFlags);
}

class ModuleBrowser;
class ModuleViewFactory;

class ModuleBrowserPlugin: public Plugin
{
public:
    ModuleBrowserPlugin(HMODULE libhandle, const char* libname, const char* libpath, int flags);
    ~ModuleBrowserPlugin();
    virtual void pluginLoaded();
    virtual void initPlugin();
    virtual void finalizePlugin();
    virtual void unloadingPlugin();
private:
    // Plugin version
    const Version* _pluginVersion;
    // Kernel API version required by this Plugin
    const Version* _pluginAPIVersion;
    // Plugin info
    const Info* _pluginInfo;

    ModuleBrowser* browser;
    ModuleViewFactory* factory;
};

#endif
